{Copyright Francesco Savastano 2001 : This source is free , but you
 cannot distribute it , if you want others have it , let them know
 to come to my web site : http://digilander.iol.it/gensavas/francosava/
If you put this algorithm in your free or commercial software i'd like my name in your thanx list .
 also check out my photoretouch program at : http://web.tiscalinet.it/new_world_software/ }

 {Description :unit to implement the famous magic wand algorithm : an other secret is revealed !
 the use of this unit is shown in the attached delphi sample program }
 unit magwand;



interface


uses
  Windows,SysUtils, Classes, Graphics,math;

type
tbool2darray=array of array of boolean;
procedure magicwand(var bitmap1:tbitmap;a,b:integer;oldcolor:tcolor;tolerance:real;var mask:tbool2darray);
procedure exec(var bitmap1:tbitmap;xf,yf:integer;var nf:integer;oldcolor:tcolor;tolerance:real;var mask:tbool2darray);
procedure showmagicwand(var bitmap1:tbitmap;var mask:tbool2darray);


implementation
type
  trgbtriplerow=array[0..30000]of trgbtriple;
  prgbtriplerow=^trgbtriplerow;

var
  fillx:array[0..80000]of integer;
  filly:array[0..80000]of integer;


  {magic wand algorithm same as seed fill algorithm}
procedure magicwand;
var
  nf:integer;
  i,ir:integer;
  xf,yf:integer;
begin
nf := 1;
ir := 1;
fillx[nf]:= a;
filly[nf]:= b;
exec(bitmap1,a,b,nf,oldcolor,tolerance,mask);
while nf>ir do
begin
ir := ir+1;
xf := fillx[ir];
yf := filly[ir];
exec(bitmap1,xf,yf,nf,oldcolor,tolerance,mask);
if (nf>75000)  then
begin
for i := 1 to nf-ir do
begin
fillx[i] := fillx[ir+i];
filly[i] := filly[ir+i];
end;
nf := nf-ir ;
ir := 0;
end;
end;
end;


procedure exec;
var
hh,ll,ss,h1,l1,s1,aa,bb,cc:real;
c1,c2,c3,pixr,pixg,pixb,oldr,oldg,oldb,newr,newg,newb:byte;
pix:tcolorref;
jj:byte;
xr,yr:longint;
gray:real;
pp:prgbtriplerow;
begin
oldr:=getrvalue(oldcolor);
oldg:=getgvalue(oldcolor);
oldb:=getbvalue(oldcolor);

for jj:=1 to 4 do
begin
if jj=1 then
begin
xr:=xf+1;
yr:=yf;
end;
if jj=2 then
begin
xr:=xf-1;
yr:=yf;
end;
if jj=3 then
begin
xr:=xf;
yr:=yf+1;
end;
if jj=4 then
begin
xr:=xf;
yr:=yf-1;
end;
if ((xr< bitmap1.width)and(jj=1))or((xr>=0)and(jj=2))
or ((yr< bitmap1.height)and(jj=3))or((yr>=0)and(jj=4)) then
begin
pp:=bitmap1.scanline[yr];
pix:=rgb(pp[xr].rgbtred,pp[xr].rgbtgreen,pp[xr].rgbtblue);
pixr:=getrvalue(pix);
pixg:=getgvalue(pix);
pixb:=getbvalue(pix);
if (not mask[xr,yr])and(abs(pixr-oldr)<=tolerance*150)and(abs(pixg-oldg)<=tolerance*150)and(abs(pixb-oldb)<=tolerance*150)then
begin
mask[xr,yr]:=true;
nf := nf+1;
fillx[nf]:= xr;
filly[nf]:= yr;
end;
end;
end;
end;

{This is only one of possible ways to show the result of the magic wand selection (stored in the array "mask" ) onto a bitmap ,
sorry but the selection will not be animated like you see in some photoretouch softwares ,
but i don't think this is very difficult to do !}

procedure showmagicwand;
var
i,j:integer;
test:boolean;
pp:prgbtriplerow;
begin
for j:=1 to bitmap1.height-2 do
begin
pp:=bitmap1.scanline[j];
for i:=1 to bitmap1.width-2 do
begin
if mask[i,j]then
begin
test:= mask[i-1,j] and mask[i+1,j] and mask[i,j-1] and mask[i,j+1] ;
if not test then
begin
{simply invert the colors of the boundary pixels }
with pp[i] do
begin
rgbtred:=255-rgbtred;
rgbtgreen:=255-rgbtgreen;
rgbtblue:=255-rgbtblue;
end;
end;
end;
end;
end;
end;




end.
 