{Copyright Francesco Savastano 1999-2000 all rights reserved}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    TrackBar1: TTrackBar;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    Label3: TLabel;
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses magwand;
{$R *.DFM}

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
  bit:tbitmap;
  ind:integer;
  mask:tbool2darray;
  begin

screen.cursor:=crhourglass;

// if you want to reload each time the bitmap then active the following code
{
if opendialog1.filename<>'' then
begin
image1.picture.bitmap.LoadFromFile(opendialog1.filename);
image1.picture.bitmap.pixelformat:=pf24bit;
image1.Picture.Bitmap.Canvas.brush.color:=clyellow;
image1.picture.bitmap.canvas.textout(0,0,'Copyright Francesco Savastano 1999-2000');
end;}

bit:=tbitmap.create;
bit.assign(image1.picture.bitmap);
bit.pixelformat:=pf24bit;
Setlength(mask,bit.width+5,bit.height+5);
magicwand(bit,x,y,bit.canvas.pixels[x,y],trackbar1.Position/100,mask);
showmagicwand(bit,mask);
mask:=nil;
image1.picture.bitmap:=bit;
bit.free;
screen.cursor:=crdefault;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
if opendialog1.execute then
begin
image1.picture.bitmap.LoadFromFile(opendialog1.filename);
image1.picture.bitmap.pixelformat:=pf24bit;
image1.Picture.Bitmap.Canvas.brush.color:=clyellow;
image1.picture.bitmap.canvas.textout(0,0,'Copyright Francesco Savastano 1999-2000');
end;
end;

end.
